#ifndef _QUEUE_H_
#define _QUEUE_H_

#include <pthread.h>

struct queue_entry_s {
  void *data;
  struct queue_entry_s *next;
  struct queue_entry_s *prev;
};

typedef struct queue_entry_s queue_entry_t;

struct queue_s {
  queue_entry_t *tail;
  queue_entry_t *head;
  pthread_mutex_t mutex;
  pthread_cond_t cond;
};

typedef struct queue_s ht_queue_t;

void queue_init(ht_queue_t *q);
void queue_destroy(ht_queue_t *q);
int queue_put(ht_queue_t *q, void *d);
void *queue_get_wait(ht_queue_t *q);


#endif /* _QUEUE_H_ */  

  
